<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="用户ID" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入用户ID" />
      </el-form-item>
      <el-form-item label="名称" prop="firstName">
        <el-input v-model="formData.firstName" placeholder="请输入名称" />
      </el-form-item>
      <el-form-item label="姓氏" prop="lastName">
        <el-input v-model="formData.lastName" placeholder="请输入姓氏" />
      </el-form-item>
      <el-form-item label="邮箱" prop="email">
        <el-input v-model="formData.email" placeholder="请输入邮箱" />
      </el-form-item>
      <el-form-item label="国家" prop="country">
        <el-input v-model="formData.country" placeholder="请输入国家" />
      </el-form-item>
      <el-form-item label="街道" prop="streetAddress">
        <el-input v-model="formData.streetAddress" placeholder="请输入街道" />
      </el-form-item>
      <el-form-item label="州" prop="state">
        <el-input v-model="formData.state" placeholder="请输入州" />
      </el-form-item>
      <el-form-item label="邮编" prop="postalCode">
        <el-input v-model="formData.postalCode" placeholder="请输入邮编" />
      </el-form-item>
      <el-form-item label="语言" prop="language">
        <el-input v-model="formData.language" placeholder="请输入语言" />
      </el-form-item>
      <el-form-item label="时区" prop="userZone">
        <el-input v-model="formData.userZone" placeholder="请输入时区" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as UserExtensionApi from '@/api/member/userExtension'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  userId: undefined,
  firstName: undefined,
  lastName: undefined,
  email: undefined,
  country: undefined,
  streetAddress: undefined,
  state: undefined,
  postalCode: undefined,
  language: undefined,
  userZone: undefined
})
const formRules = reactive({
  userId: [{ required: true, message: '用户ID不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await UserExtensionApi.getUserExtension(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as UserExtensionApi.UserExtensionVO
    if (formType.value === 'create') {
      await UserExtensionApi.createUserExtension(data)
      message.success(t('common.createSuccess'))
    } else {
      await UserExtensionApi.updateUserExtension(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    userId: undefined,
    firstName: undefined,
    lastName: undefined,
    email: undefined,
    country: undefined,
    streetAddress: undefined,
    state: undefined,
    postalCode: undefined,
    language: undefined,
    userZone: undefined
  }
  formRef.value?.resetFields()
}
</script>
